<!DOCTYPE html>
<html lang="en">

<head>
  <title>Danh Sách Sản Phẩm</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
  <div class="container-fluid">
    <!-- Vùng header -->
    <h3 class="text-center mt-3 font-weight-bolder">DANH SÁCH SẢN PHẨM</h3>
    <div class="container-fluid jumbotron d-flex">
      <div class="form-group col-5 row">
        <label for="select-country" class="col-3 col-form-label">Quốc gia</label>
        <div class="col-9">
          <select name="select-country" id="select-country" class="form-control select-country">
            <option value="None">-- Chọn quốc gia --</option>
          </select>
        </div>
      </div>
      <div class="form-group col-5 row">
        <label for="select-categories" class="col-3 col-form-label">Nhóm sản phẩm</label>
        <div class="col-9">
          <select name="select-categories" id="select-categories" class="form-control select-categories">
            <option value="None">-- Chọn nhóm sản phẩm --</option>
          </select>
        </div>
      </div>
      <div class="form-group col-2">
        <button class="btn btn-success"> Lọc sản phẩm</button>
      </div>
    </div>
    <div class="form-group">
      <button class="btn btn-success" id="btn-them-san-pham"><i class="fa fa-plus"></i>&nbsp; Thêm sản phẩm</button>
    </div>
    <!-- Vùng Table -->
    <table id="product-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>STT</th>
          <th>Mã sản phẩm</th>
          <th>Tên sản phẩm</th>
          <th>Nhóm sản phẩm</th>
          <th>Quốc gia</th>
          <th>Ảnh đại diện</th>
          <th>Giá bán</th>
          <th>Giá giảm</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>

  <!-- Vùng Modal: hãy tạo các modal ở bên dưới đây -->
  <!-- Modal sửa -->
  <div>
    <div class="modal fade" id="modal-update-product">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Sửa thông tin sản phẩm</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <div class="form-group row">
              <label for="inp-product-code-modal" class="col-4 col-form-label">Mã sản phẩm</label>
              <div class="col-8">
                <input type="text" class="form-control" id="inp-product-code-modal">
              </div>
            </div>
            <div class="form-group row">
              <label for="txt-product-name-modal" class="col-4 col-form-label">Tên sản phẩm</label>
              <div class="col-8">
                <textarea name="txt-product-name-modal" id="txt-product-name-modal" rows="2" class="form-control"></textarea>
              </div>
            </div>
            <div class="form-group row">
              <label for="select-categories-modal" class="col-4 col-form-label">Nhóm sản phẩm</label>
              <div class="col-8">
                <select name="select-categories-modal" id="select-categories-modal"
                  class="form-control select-categories"></select>
              </div>
            </div>
            <div class="form-group row">
              <label for="select-country-modal" class="col-4 col-form-label">Quốc gia</label>
              <div class="col-8">
                <select name="select-country-modal" id="select-country-modal" class="form-control select-country"></select>
              </div>
            </div>
            <div class="form-group row">
              <label for="txt-image-url-modal" class="col-4 col-form-label">Image Url:</label>
              <div class="col-8">
                <image id="image" rows="3" class="form-control">
              </div>
            </div>
            <div class="form-group row">
              <label for="txt-product-des-modal" class="col-4 col-form-label">Mô tả sản phẩm:</label>
              <div class="col-8">
                <textarea name="txt-product-des-modal" id="txt-product-des-modal" rows="4" class="form-control"></textarea>
              </div>
            </div>
            <div class="form-group row">
              <label for="inp-price-modal" class="col-4 col-form-label">Giá bán</label>
              <div class="col-8">
                <input type="text" class="form-control" id="inp-price-modal">
              </div>
            </div>
            <div class="form-group row">
              <label for="inp-discount-price-modal" class="col-4 col-form-label">Giá giảm</label>
              <div class="col-8">
                <input type="text" class="form-control" id="inp-discount-price-modal" readonly
                  style="background-color: white;">
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" data-dismiss="modal">Hủy</button>
            <button class="btn btn-primary" id="btn-update-product-modal">Sửa</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
  $(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1";
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gPRODUCT_COLS = ["stt", "productCode", "productName", "categoryId", "countryId", "imagUrl", "price", "discountPrice", "id"];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gPRODUCT_STT_COL = 0;
    const gPRODUCT_MA_SAN_PHAM_COL = 1;
    const gPRODUCT_TEN_SAN_PHAM_COL = 2;
    const gPRODUCT_NHOM_SAN_PHAM_COL = 3;
    const gPRODUCT_QUOC_GIA_COL = 4;
    const gPRODUCT_ANH_DAI_DIEN_COL = 5;
    const gPRODUCT_GIA_BAN_COL = 6;
    const gPRODUCT_GIA_GIAM_COL = 7;
    const gPRODUCT_ACTION_COL = 8;
    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gProductTable = $("#product-table").DataTable({
      columns: [
        { data: gPRODUCT_COLS[gPRODUCT_STT_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_MA_SAN_PHAM_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_TEN_SAN_PHAM_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_NHOM_SAN_PHAM_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_QUOC_GIA_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_ANH_DAI_DIEN_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_GIA_BAN_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_GIA_GIAM_COL] },
        { data: gPRODUCT_COLS[gPRODUCT_ACTION_COL] },
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gPRODUCT_STT_COL,
          render: function () {
            return gSTT++;
          }
        },
        { // định nghĩa lại cột nhóm sản phẩm
          targets: gPRODUCT_NHOM_SAN_PHAM_COL,
          render: function (paramData) {
            for (var bI = 0; bI < gCategoryArray.length; bI++) {
              if (paramData == gCategoryArray[bI].id) {
                return gCategoryArray[bI].categoryName;
              }
            }
          }
        },
        { // định nghĩa lại cột quốc gia
          targets: gPRODUCT_QUOC_GIA_COL,
          render: function (paramData) {
            for (var bI = 0; bI < gCountryArray.length; bI++) {
              if (paramData == gCountryArray[bI].id) {
                return gCountryArray[bI].countryName;
              }
            }
          }
        },
        { // định nghĩa lại cột ảnh đại diện
          targets: gPRODUCT_ANH_DAI_DIEN_COL,
          render: function (paramData) {
            return `<img src="${paramData}" alt="" style="width: 100%;">`
          }
        },
        { // định nghĩa lại cột giá bán
          targets: gPRODUCT_GIA_BAN_COL,
          render: function (paramData) {
            return "$ " + paramData
          }
        },
        { // định nghĩa lại cột giá giảm
          targets: gPRODUCT_GIA_GIAM_COL,
          render: function (paramData) {
            return "$ " + paramData
          }
        },
        { // định nghĩa lại cột action
          targets: gPRODUCT_ACTION_COL,
          render: function (paramData) {
            return `
        <img class="edit-product" data-id=${paramData} src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
        <img class="delete-product" data-id=${paramData} src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
      `
          }
        }
      ]
    });
    // Biến toàn cục để lưu các mảng giá trị
    var gProductArray = [];
    var gCountryArray = [];
    var gCategoryArray = [];
    // Biến toàn cục để lưu id product
    var gProductId = 0;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // thực hiện tải trang
    onPageLoading();

    
    $("#product-table").on("click", ".edit-product", function () {
      onBtnEditProductClick(this);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      //Read / Load category to select element
      getAllCategory();
      //Read / Load country to select element
      getAllCountry();
      //Read / Load product to DataTable
      getAllProducts();
    }

    function onBtnEditProductClick(paramBtnEdit) {
      // lưu thông tin productId đang được edit vào biến toàn cục
      gProductId = $(paramBtnEdit).data("id");
      $("#modal-update-product").modal("show");
      // load dữ liệu vào các trường dữ liệu trong modal
      getProductByIdAndLoadToUpdateModal(gProductId);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách product
    function getAllProducts() {
      $.ajax({
        url: gBASE_URL + "/products/",
        type: "GET",
        success: function (paramProducts) {
          gProductArray = paramProducts;
          console.log(gProductArray);
          loadDataToProductTable(gProductArray);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load Product array to DataTable */
    function loadDataToProductTable(paramProductArray) {
      gSTT = 1;
      gProductTable.clear();
      gProductTable.rows.add(paramProductArray);
      gProductTable.draw();
    }
    // hàm gọi api để lấy all danh sách country
    function getAllCountry() {
      $.ajax({
        url: gBASE_URL + "/countries/",
        type: "GET",
        success: function (paramCountries) {
          gCountryArray = paramCountries;
          console.log(gCountryArray);
          loadDataToCountrySelect(gCountryArray);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load Country array to Select Element */
    function loadDataToCountrySelect(paramCountryArray) {
      var vSelectCountryElement = $(".select-country");
      for (var bI = 0; bI < paramCountryArray.length; bI++) {
        $("<option>").val(paramCountryArray[bI].countryCode).html(paramCountryArray[bI].countryName).appendTo(vSelectCountryElement);
      }
    }
    // hàm gọi api để lấy all danh sách category
    function getAllCategory() {
      $.ajax({
        url: gBASE_URL + "/categories/",
        type: "GET",
        success: function (paramCategories) {
          gCategoryArray = paramCategories;
          console.log(gCategoryArray);
          loadDataToCategorySelect(gCategoryArray);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load Category array to Select Element */
    function loadDataToCategorySelect(paramCategoryArray) {
      var vSelectCountryElement = $(".select-categories");
      for (var bI = 0; bI < paramCategoryArray.length; bI++) {
        $("<option>").val(paramCategoryArray[bI].categoryCode).html(paramCategoryArray[bI].categoryName).appendTo(vSelectCountryElement);
      }
    }
    // hàm gọi api để lấy product by id
    function getProductByIdAndLoadToUpdateModal(paramProductId){
      $.ajax({
        url: gBASE_URL + "/products/" + paramProductId,
        type: "GET",
        success: function (paramProduct) {
          console.log(paramProduct);
          loadDataToUpdateModal(paramProduct);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load Product to Update Modal */
    function loadDataToUpdateModal(paramProduct) {
      $("#inp-product-code-modal").val(paramProduct.productCode);
      $("#txt-product-name-modal").val(paramProduct.productName);
      for(var bI = 0; bI < gCategoryArray.length; bI++) {
        if(paramProduct.categoryId == gCategoryArray[bI].id) {
          $("#select-categories-modal").val(gCategoryArray[bI].categoryCode);
        }
      }
      for(var bI = 0; bI < gCountryArray.length; bI++) {
        if(paramProduct.countryId == gCountryArray[bI].id) {
          $("#select-country-modal").val(gCountryArray[bI].countryCode);
        }
      }
      $("#image").prop("src",paramProduct.imagUrl).css({ 'height': '150px', 'width': '150px' });
      $("#txt-product-des-modal").val(paramProduct.description);
      $("#inp-price-modal").val(paramProduct.price);
      $("#inp-discount-price-modal").val(paramProduct.discountPrice);
    }
  

  });


</script>

</html>